<template>
  <q-page class="flex-center">
    <template>
      <div class="q-pa-md row items-start q-gutter-md">
        <q-card class="q-pa-md">
          <q-card-section class="q-gutter-sm">
            <div class="text-subtitle2">Type Game</div>
            <q-option-group
              v-model="game_type"
              :options="type_options"
              inline
              color="green"
              type="checkbox"
            />
          </q-card-section>
          <q-card-section class="q-gutter-sm">
            <p class="el-input text-h6" style="width: 50px">From:</p>
            <el-date-picker
              v-model="picker.start_date"
              type="date"
              placeholder="Select Start Date"
            ></el-date-picker>
            <el-time-select
              v-model="picker.start_time"
              placeholder="Select Start time"
              :picker-options="{
                start: '00:00',
                step: '00:01',
                end: '23:00'
              }"
            >
            </el-time-select>
            To
            <el-date-picker
              v-model="picker.end_date"
              type="date"
              placeholder="Select End Date"
            ></el-date-picker>
            <el-time-select
              v-model="picker.end_time"
              placeholder="Select End time"
              :picker-options="{
                start: '00:00',
                step: '00:01',
                end: '23:00'
              }"
            >
            </el-time-select>
          </q-card-section>
          <!-- <q-card-section>
            <p class="el-input text-h6" style="width: 130px">Company Name:</p>
            <el-input
              placeholder="Please Company Name"
              v-model="filter.compane"
            ></el-input>
          </q-card-section> -->
          <q-card-actions class="footer_filter">
            <q-btn color="primary" @click="getdata()">Search</q-btn>
            <q-btn color="amber" @click="clearInput()">Clear</q-btn>
            <h5>ข้อมูลจะอัพเดต ทุกๆ 15 นาที</h5>
          </q-card-actions>
        </q-card>
      </div>
      <div class="q-pa-md row items-start q-gutter-md">
        <q-card class="q-pa-md px-15">
          <span
            v-for="(val, index) in navbar"
            :key="index"
            class="pointer head_navbar"
            @click="
              ChangeNavbar(val.parent_id || 0, val.level, val.username, index)
            "
          >
            {{ val.label }}
            <span
              v-if="
                navbar.length > 1 && index != Object.keys(navbar).length - 1
              "
              class="text-dark"
            >
              /
            </span>
          </span>
        </q-card>
      </div>

      <div class="q-pa-md">
        <q-table
          :rows-per-page-options="[15, 25, 50]"
          :data="data"
          :columns="columns"
          :separator="separator"
          :pagination.sync="pagination"
          row-key="col1"
          class="my-sticky-header-column-table"
          :loading="loading"
        >
          <template
            slot="header"
            slot-scope="props"
            style="
              display: contents;
              vertical-align: middle;
              text-align: center;
            "
          >
            <q-tr v-if="level == 1">
              <q-th
                rowspan="2"
                class="bg-blue-9 text-white"
                v-for="(col, index) in header_columns_ori"
                :key="index"
                >{{ col }}</q-th
              >

              <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Senior</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Share</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Company</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Smart Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Provider</q-th>
            </q-tr>
            <q-tr v-if="level == 1">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 7"
                :key="index"
                >W/L</q-th
              >
              <!-- <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th> -->
            </q-tr>

            <q-tr v-if="level == 2">
              <q-th
                rowspan="2"
                class="bg-blue-9 text-white"
                v-for="(col, index) in header_columns_ori"
                :key="index"
                >{{ col }}</q-th
              >

              <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Senior</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Share</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Company</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Smart-Agent</q-th>
            </q-tr>
            <q-tr v-if="level == 2">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 6"
                :key="index"
                >W/L</q-th
              >
            </q-tr>

            <q-tr v-if="level == 3">
              <q-th
                rowspan="2"
                class="bg-blue-9 text-white"
                v-for="(col, index) in header_columns_ori"
                :key="index"
                >{{ col }}</q-th
              >
              <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Senior</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Share</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Company</q-th>
            </q-tr>
            <q-tr v-if="level == 3">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 5"
                :key="index"
                >W/L</q-th
              >
            </q-tr>

            <q-tr v-if="level == 4">
              <q-th
                rowspan="2"
                class="bg-blue-9 text-white"
                v-for="(col, index) in header_columns_ori"
                :key="index"
                >{{ col }}</q-th
              >
              <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white" width="15%"
                >Senior</q-th
              >
              <q-th colspan="1" class="bg-blue-10 text-white">Share</q-th>
            </q-tr>
            <q-tr v-if="level == 4">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 4"
                :key="index"
                >W/L</q-th
              >
            </q-tr>

            <q-tr v-if="level == 5">
              <q-th
                rowspan="2"
                class="bg-blue-9 text-white"
                v-for="(col, index) in header_columns_ori"
                :key="index"
                >{{ col }}</q-th
              >
              <q-th colspan="1" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white" width="15%"
                >Senior</q-th
              >
            </q-tr>
            <q-tr v-if="level == 5">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 3"
                :key="index"
                >W/L</q-th
              >
            </q-tr>

            <q-tr v-if="level == 6">
              <q-th rowspan="2" class="bg-blue-10 text-white">username</q-th>
              <q-th rowspan="2" class="bg-blue-10 text-white">info</q-th>
              <q-th rowspan="2" class="bg-blue-10 text-white">event</q-th>
              <q-th rowspan="2" class="bg-blue-10 text-white">detail</q-th>

              <q-th rowspan="2" class="bg-blue-10 text-white">Member</q-th>
              <q-th rowspan="2" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white" width=""
                >Senior</q-th
              >
              <q-th colspan="1" class="bg-blue-10 text-white">Share</q-th>
              <q-th colspan="1" class="bg-blue-10 text-white">company</q-th>
              <!-- <q-th colspan="1" class="bg-blue-10 text-white">Smart-Agent</q-th> -->
            </q-tr>
            <q-tr v-if="level == 6">
              <q-th
                class="bg-light-blue-5 text-white"
                v-for="(i, index) in 3"
                :key="index"
                >W/L</q-th
              >
            </q-tr>
          </template>

          <template slot="body" slot-scope="props">
            <!-- <q-tr :props="props">
              <q-td v-for="col in columns[0]" :key="col" :props="props">
                  {{col}}
                  {{ props.row['username'] }}
              </q-td>
            </q-tr> -->
            <q-tr>
              <q-td v-for="(col, index) in columns[level]" :key="index">
                <div
                  class="pointer"
                  :class="{ 'text-center': index >= 1 }"
                  v-if="props.row['parent_id']"
                  @click="
                    OpenSub(
                      props.row['parent_id'],
                      props.row['level'],
                      props.row['username']
                    )
                  "
                >
                  <!-- <span v-if="level == 3 && col == 'companys'">
                    {{
                      props.row["member"] * -1 -
                      (props.row["agent"] +
                        props.row["senior"] +
                        props.row["share"])
                    }}
                  </span>
                  <span v-else>
                    {{ col == "currency" ? "THB" : props.row[col] }}
                  </span> -->
                  <span
                    v-if="
                      col != 'username' &&
                        col != 'role' &&
                        col != 'currency' &&
                        col != 'detail'
                    "
                    >{{
                      col == "currency" ? "THB" : props.row[col] | formatPrice
                    }}
                  </span>
                  <span v-else>{{
                    col == "currency" ? "THB" : props.row[col]
                  }}</span>
                </div>
                <div
                  v-else
                  :class="{ 'text-center': index >= 1 }"
                  class="row_data"
                >
                  <div v-if="col == 'info' && props.row.info">
                    <p class="pt-3">
                      <b>Username</b> : {{ props.row.info.username }}
                    </p>
                    <p><b>ref_no</b> : {{ props.row[col].ref_no }}</p>
                    <p><b>Time</b> : {{ props.row[col].start_time }}</p>
                  </div>
                  <div v-else-if="col == 'event' && props.row.event">
                    <p class="pt-3">
                      <b>Provider</b> :{{ props.row[col].provider }}
                    </p>
                    <p><b>Game Type</b> : {{ props.row[col].gameType }}</p>
                    <p><b>Bet</b> : {{ props.row[col].bet }}</p>
                    <p><b>Game id</b> : {{ props.row[col].game_id }}</p>
                  </div>
                  <div v-else>
                    <span
                      v-if="
                        col != 'username' &&
                          col != 'role' &&
                          col != 'currency' &&
                          col != 'detail'
                      "
                      >{{
                        col == "currency" ? "THB" : props.row[col] | formatPrice
                      }}
                    </span>
                    <span v-else>{{
                      col == "currency" ? "THB" : props.row[col]
                    }}</span>
                  </div>
                </div>
              </q-td>
            </q-tr>
            <!-- <q-tr :props="props">
              <q-td
                :class="{
                  'bg-yellow-5': col.field.includes('_winlose_commission'),
                }"
                v-for="col in props.cols"
                :key="col.name"
                :props="props"
              >
                {{ props.row[col.field] }}
              </q-td>
            </q-tr> -->
          </template>
          <!-- <template v-slot:bottom-row>
            <q-tr>
              <q-td class="total"> Total</q-td>
              <q-td v-for="index in 7"> col</q-td>
            </q-tr>
          </template> -->
          <template v-slot:bottom>
            <q-card-actions class="">
              <q-btn
                color="deep-orange"
                @click="previous()"
                v-if="footer_table.previous"
                >previous</q-btn
              >

              <q-btn
                color="deep-orange"
                @click="next()"
                class="f_right"
                v-if="footer_table.next"
                >next
              </q-btn>
            </q-card-actions>
          </template>
        </q-table>
      </div>
    </template>
  </q-page>
</template>

<script>
import { Loading, QSpinnerGears } from "quasar";
import moment from "moment";
import company from "src/services/company";

export default {
  name: "Report",
  data() {
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "owner",
          align: "left",
          label: "companys",
          field: "company_name",
          sortable: true
        },
        {
          name: "contact",
          align: "left",
          label: "contact",
          field: "fullname",
          sortable: true
        },
        {
          name: "currency",
          align: "left",
          label: "currency",
          field: "currency",
          sortable: true
        },
        {
          name: "amount",
          align: "left",
          label: "amount",
          field: "credit",
          sortable: true
        },
        {
          name: "valid_amount",
          align: "right",
          label: "valid_amount",
          field: "valid_amount",
          sortable: true
        },
        {
          name: "stake_count",
          align: "right",
          label: "stake_count",
          field: "stake_count",
          sortable: true
        },
        {
          name: "gross_commission",
          align: "right",
          label: "gross_commission",
          field: "gross_commission",
          sortable: true
        },
        {
          name: "member_winlose",
          align: "right",
          label: "member_winlose",
          field: "member_winlose",
          sortable: true
        },
        {
          name: "member_commission",
          align: "right",
          label: "member_commission",
          field: "member_commission",
          sortable: true
        },
        {
          name: "member_winlose_commission",
          align: "right",
          label: "member_winlose_commission",
          field: "member_winlose_commission",
          sortable: true
        },
        {
          name: "agent_winlose",
          align: "right",
          label: "agent_winlose",
          field: "agent_winlose",
          sortable: true
        },
        {
          name: "agent_commission",
          align: "right",
          label: "agent_commission",
          field: "agent_commission",
          sortable: true
        },
        {
          name: "agent_winlose_commission",
          align: "right",
          label: "agent_winlose_commission",
          field: "agent_winlose_commission",
          sortable: true
        },
        {
          name: "senior_winlose",
          align: "right",
          label: "senior_winlose",
          field: "senior_winlose",
          sortable: true
        },
        {
          name: "senior_commission",
          align: "right",
          label: "senior_commission",
          field: "senior_commission",
          sortable: true
        },
        {
          name: "senior_winlose_commission",
          align: "right",
          label: "senior_winlose_commission",
          field: "senior_winlose_commission",
          sortable: true
        }
      ],
      filter: {},
      select_game_type: [],
      type_options: [],
      separator: "cell",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      options: [
        { value: 3, label: "Please Select" },
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      permissions:
        this.$q.sessionStorage.getItem("permissions")["company"] != undefined
          ? this.$q.sessionStorage.getItem("permissions")["company"]
          : [],
      picker: {
        start_date: moment(String(moment().startOf("day"))).format(
          "YYYY-MM-DD"
        ),
        end_date: moment(String(moment().startOf("day"))).format("YYYY-MM-DD"),
        start_time: "00:00",
        end_time: "23:59"
      },
      level: 1,
      header_columns_ori: [
        "Username",
        "Role",
        "Currency",
        "Amount",
        "Stake Count"
      ],
      game_type: {},
      columns: [
        [],
        [
          "username",
          "role",
          "currency",
          "bet",
          "count",
          "member",
          "agent",
          "senior",
          "share",
          "companys",
          "smart_agent",
          "provider"
        ],
        [
          "username",
          "role",
          "currency",
          "bet",
          "count",
          "member",
          "agent",
          "senior",
          "share",
          "companys",
          "smart_agent"
        ],
        [
          "username",
          "role",
          "currency",
          "bet",
          "count",
          "member",
          "agent",
          "senior",
          "share",
          "companys"
        ],
        [
          "username",
          "role",
          "currency",
          "bet",
          "count",
          "member",
          "agent",
          "senior",
          "share"
        ],
        [
          "username",
          "role",
          "currency",
          "bet",
          "count",
          "member",
          "agent",
          "senior"
        ],
        [
          "username",
          "info",
          "event",
          "detail",
          "member",
          "agent",
          "senior",
          "share",
          "companys"
          // "smart_agent",
        ]
      ],
      navbar: [],
      loading: false,
      role_report: [
        "provider",
        "smart_agent",
        "companys",
        "share",
        "senior",
        "agent",
        "member"
      ],
      role: ["Admin", "Owner", "Shareholder", "Senior", "agent", "เมมเบอร์"],
      provider: [],
      obj_game_type: [],
      level_start: 1,
      start_page: true,
      username: this.$q.sessionStorage.getItem("username"),
      user_role: this.$q.sessionStorage.getItem("role"),
      total: {},
      footer_table: { pervios: false, next: false },
      data_footer: []
    };
  },

  async created() {
    // var starttime = moment().startOf("day");
    // this.picker.start_date = this.picker.end_date = moment(
    //   String(starttime)
    // ).format("YYYY-MM-DD");
    // this.picker.start_time = "00:00";
    // this.picker.end_time = "23:59";

    await this.get_type();
    await this.getdata();
    await this.get_provider();
  },

  methods: {
    async onRequest(props, event = "next") {
      try {
        Loading.show();

        this.total = {};

        // try {
        this.filter.game_type = this.game_type.toString();

        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;

        this.filter.page_limit = 10;
        this.filter.page = 1;
        // if (this.filter.name == "") {
        //   delete this.filter.name;
        // }

        if (this.picker.start_date || this.picker.start_time) {
          this.filter.datetime_start =
            moment(String(this.picker.start_date)).format("YYYY-MM-DDT") +
            (this.picker.start_time || "00:00") +
            ":00Z";
        }
        if (this.picker.end_date || this.picker.end_time) {
          this.filter.datetime_end =
            moment(String(this.picker.end_date)).format("YYYY-MM-DDT") +
            (this.picker.end_time || "00:00") +
            ":00Z";
        }

        if (this.filter.status == 3) {
          delete this.filter.status;
        }
        // let result = await this.$services.company.read(this.filter);
        let result = await this.$services.report.read(this.filter);
        // console.log("result.totalCount " + result.totalCount);

        if (result && result.results) {
          this.data = result.results;
          this.data.page = this.filter.page;
          if (this.start_page) {
            var levels = parseInt(this.user_role) || 1;
            if (this.data[0] && parseInt(this.data[0].level != 2)) {
              levels = parseInt(this.data[0].report[0].role) + 1;
            }
            this.navbar.push({
              label: this.username,
              parent_id: 0,
              level: levels
            });
            this.start_page = false;
            this.level_start = this.level = levels;
          }

          var obj = result.results;
          // console.log(obj[0].report);
          obj.forEach((obj_array, key_obj) => {
            var member_5;
            obj_array.report.forEach((val, index) => {
              if (val.role == "2") {
                this.data[key_obj].companys =
                  parseFloat(val.billing) == 0
                    ? this.changebilling(
                        this.data[key_obj].winLoss,
                        val.percent
                      )
                    : this.parseFloat(val.billing);
                this.total.companys =
                  this.parseFloat(this.data[key_obj].companys) +
                  (this.parseFloat(this.total.companys) || 0);
              } else if (val.role == "3") {
                this.data[key_obj].share =
                  (parseFloat(val.billing) == 0
                    ? this.changebilling(
                        this.data[key_obj].winLoss,
                        val.percent
                      )
                    : this.parseFloat(val.billing)) || 0;
                this.total.share =
                  this.parseFloat(this.data[key_obj].share) +
                  (this.parseFloat(this.total.share) || 0);
              } else if (val.role == "4") {
                this.data[key_obj].senior =
                  parseFloat(val.billing) == 0
                    ? this.changebilling(
                        this.data[key_obj].winLoss,
                        val.percent
                      )
                    : this.parseFloat(val.billing);
                this.total.senior =
                  this.parseFloat(this.data[key_obj].senior) +
                  (this.parseFloat(this.total.senior) || 0);
              } else if (val.role == "5") {
                member_5 = val.winLoss;
                this.data[key_obj].agent =
                  (parseFloat(val.billing) == 0
                    ? this.changebilling(
                        this.data[key_obj].winLoss,
                        val.percent
                      )
                    : this.parseFloat(val.billing)) || 0;
                this.total.agent =
                  this.parseFloat(this.data[key_obj].agent) +
                  (this.parseFloat(this.total.agent) || 0);
              } else {
                this.data[key_obj].member =
                  (parseFloat(val.winLoss) == 0
                    ? this.changebilling(
                        this.data[key_obj].winLoss,
                        val.percent
                      )
                    : this.parseFloat(val.winLoss)) * -1;
                this.total.member =
                  (this.parseFloat(
                    0
                      ? this.changebilling(
                          this.data[key_obj].winLoss,
                          val.percent
                        )
                      : this.parseFloat(val.winLoss)
                  ) +
                    (this.parseFloat(this.total.member) || 0)) *
                  -1;
              }
              if (obj_array.level == parseInt(val.role)) {
                this.data[key_obj].bet = parseFloat(val.bet);
                this.data[key_obj].count = parseFloat(val.count);
              }
            });
            // console.log('bet = '+JSON.stringify(obj_array.report[0].bet));
            this.data[key_obj].level = obj_array.level;
            if (this.level == 1) {
              this.data[key_obj].smart_agent = this.parseFloat(
                parseFloat(this.data[key_obj].member) * -1 -
                  (this.data[key_obj].agent +
                    this.data[key_obj].senior +
                    this.data[key_obj].share +
                    this.data[key_obj].companys)
              );

              this.data[key_obj].provider = 0;

              this.total.smart_agent =
                this.parseFloat(this.data[key_obj].smart_agent) +
                this.parseFloat(this.total.smart_agent);
              this.total.provider = 0;
            } else if (this.level == 2) {
              this.data[key_obj].smart_agent = this.parseFloat(
                parseFloat(this.data[key_obj].member) * -1 -
                  (this.data[key_obj].agent +
                    this.data[key_obj].senior +
                    this.data[key_obj].share +
                    this.data[key_obj].companys)
              );

              this.data[key_obj].provider = 0;

              this.total.smart_agent =
                this.parseFloat(this.data[key_obj].smart_agent) +
                this.parseFloat(this.total.smart_agent);

              delete this.data[key_obj].provider;
              delete this.total.provider;
            } else if (this.level == 3) {
              this.data[key_obj].companys = this.parseFloat(
                parseFloat(this.data[key_obj].member) * -1 -
                  (this.data[key_obj].agent +
                    this.data[key_obj].senior +
                    this.data[key_obj].share)
              );
              this.data[key_obj].agent = this.data[key_obj].agent || 0;
            } else if (this.level == 4) {
              this.data[key_obj].share = this.parseFloat(
                parseFloat(this.data[key_obj].member) * -1 -
                  (this.data[key_obj].agent + this.data[key_obj].senior)
              );
            } else if (this.level == 5) {
              this.data[key_obj].member = this.parseFloat(member_5 * -1);
              this.data[key_obj].senior = this.parseFloat(
                this.parseFloat(member_5) -
                  this.parseFloat(this.data[key_obj].agent)
              );
            } else if (this.level == 6) {
              this.data[key_obj].info = {};
              this.data[key_obj].info.username = obj_array.username;

              this.data[key_obj].info.ref_no = obj_array.refNumber;
              this.data[key_obj].info.start_time = obj_array.starTime;
              this.data[key_obj].event = {};
              this.data[key_obj].event.provider = this.provider[
                obj_array.providerCode
              ];
              this.data[key_obj].event.gameType = this.obj_game_type[
                obj_array.gameType
              ];
              this.data[key_obj].event.bet = obj_array.bet;
              this.data[key_obj].event.game_id = obj_array.game_id;
              this.data[key_obj].member = this.parseFloat(obj_array.winLoss);

              this.data[key_obj].smart_agent = this.parseFloat(
                this.data[key_obj].member -
                  (this.data[key_obj].agent +
                    this.data[key_obj].senior +
                    this.data[key_obj].share +
                    this.data[key_obj].companys)
              );
              this.total.smart_agent =
                this.data[key_obj].smart_agent + (this.total.smart_agent || 0);
            }
            this.total.username = "Total";
            this.total.bet = this.parseFloat(
              this.data[key_obj].bet + (this.total.bet || 0)
            );
            this.total.count = this.parseFloat(
              this.data[key_obj].count + (this.total.count || 0)
            );
          });
          this.total.companys = 0;
          this.total.member = 0;
          this.total.senior = 0;
          this.total.share = 0;
          this.total.agent = 0;
          // console.log("this.level ",JSON.stringify(this.level))
          this.data.forEach((obj_array, key_obj) => {
            if (this.level == 3) {
              this.data[key_obj].companys =
                parseFloat(this.data[key_obj].member) * -1 -
                parseFloat(
                  this.data[key_obj].agent +
                    this.data[key_obj].senior +
                    this.data[key_obj].share
                );
            }
            if (this.level == 4) {
              this.data[key_obj].agent = this.data[key_obj].agent | 0;
            }
            this.total.companys =
              parseFloat(this.data[key_obj].companys) +
              parseFloat(this.total.companys);
            this.total.member = this.parseFloat(
              this.data[key_obj].member + this.total.member
            );
            this.total.senior = this.parseFloat(
              parseFloat(this.data[key_obj].senior) +
                parseFloat(this.total.senior)
            );
            this.total.agent =
              parseFloat(this.data[key_obj].agent) +
              parseFloat(this.total.agent);

            this.total.share =
              parseFloat(this.data[key_obj].share) +
              parseFloat(this.total.share);
            // console.log('this.data[key_obj].share +',this.data[key_obj].share ,' + ',this.total.share);
          });
          // console.log("this.total.share ",this.total.share)
          if (this.level == 6) {
            this.footer_table.next = true;
            // transaction
            if (event == "next") {
              this.data_footer.push({
                transaction: this.data[this.data.length - 1].transaction
              });
            }

            this.data_footer.length > 1
              ? (this.footer_table.previous = true)
              : (this.footer_table.previous = false);
            this.data.totalCount <= 9
              ? (this.footer_table.next = false)
              : (this.footer_table.next = true);
          }

          this.pagination.rowsNumber = result.totalCount;
          const fetchCount =
            rowsPerPage === 0 ? this.pagination.rowsNumber : rowsPerPage;
          const startRow = (page - 1) * rowsPerPage;

          this.data.push(this.total);
          // console.log(this.data);

          this.$services.updateindex(this.data);
          this.pagination.page = page;
          this.pagination.rowsPerPage = rowsPerPage;
          this.pagination.sortBy = sortBy;
          this.pagination.descending = descending;
          this.loading = false;

          // console.log("this.pagination = "+JSON.stringify(this.pagination) )
        } else {
          Loading.hide();
        }
        // } catch (e) {
        //   Loading.hide();
        //   this.$services.error(e.response, this.$router);
        // }
        Loading.hide();
      } catch (ex) {
        Loading.hide();
      }
    },
    changebilling(number, percen) {
      return this.parseFloat((number * percen) / 100);
    },
    parseFloat(data) {
      if (data) {
        return parseFloat(data.toFixed(2));
      } else {
        return 0;
      }
    },
    async getdata(event) {
      this.onRequest(
        {
          pagination: this.pagination
        },
        event
      );
      this.header_columns = this.header_columns_ori;
    },

    async get_type() {
      let ctx = this;
      this.game_type = [];
      //   this.$services.typegame
      // this.$services.group
      //   .read({})
      //   .then(function (data) {

      //     data.forEach((row) => {
      //       ctx.type_options.push({ value: row.code, label: row.name });
      //       ctx.game_type.push(row.code);
      //     });

      //   })
      //   .catch(function (e) {
      //     ctx.$services.error(e.response, ctx.$route);
      //   });
      let result = await this.$services.group.read();
      if (result) {
        result.forEach(row => {
          this.type_options.push({ value: row.code, label: row.name });
          this.game_type.push(row.code);
        });
        this.obj_game_type = result.reduce(function(map, value) {
          map[value.code] = value.name;
          return map;
        }, {});
      }
    },
    async get_provider() {
      let result = await this.$services.provider.read();
      if (result) {
        this.provider = result.reduce(function(map, value) {
          map[value.code] = value.name;
          return map;
        }, {});
      }
    },
    OpenSub(parent_id, level, username) {
      this.filter.parent_id = parent_id;
      this.level = parseInt(level);

      if (parent_id && level && username) {
        this.navbar.push({
          label: username,
          parent_id: parent_id,
          level: this.level
        });
        // console.log("navbar = " + JSON.stringify(this.navbar));
      }
      this.onRequest({
        pagination: this.pagination
      });
    },
    ChangeNavbar(parent_id, level, username, row) {
      if (parent_id == 0) {
        let frist = this.navbar[0];
        this.navbar = [];
        this.navbar[0] = frist;
        delete this.filter.parent_id;
        this.getdata();
        this.level = this.level_start;
      } else {
        let removeIndex = this.navbar.length - row;
        if (this.navbar.length - 1 != row) {
          this.navbar = this.navbar.slice(0, row + 1);
        }

        this.OpenSub(parent_id, level, username);
      }
      this.data_footer = {};
      this.footer_table.previous = false;
      this.footer_table.next = false;
      if (this.filter.transaction) {
        delete this.filter.transaction;
      }
    },
    clearInput() {
      this.filter.datetime_start = "";
      this.filter.datetime_end = "";
      this.picker = {};
    },
    async next() {
      // this.filter.transaction = "";

      this.filter.transaction = this.data_footer[
        this.data_footer.length - 1
      ].transaction;
      await this.getdata("next");
    },
    async previous() {
      this.data_footer.pop();
      if (this.data_footer.length - 1 == 0) {
        delete this.filter.transaction;
        this.footer_table.previous = false;
      } else {
        this.filter.transaction = this.data_footer[
          this.data_footer.length - 2
        ].transaction;
      }
      await this.getdata("pervios");
    }
  },

  filters: {
    toUSD(value) {
      if (value) {
        return `${value.toLocaleString()}`;
      }
    },
    formatPrice(value) {
      if (value) {
        let val = (value / 1).toFixed(2).replace(",", ".");
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
      }
      return 0;
    }
  }
};
</script>

<style lang="sass">
.my-sticky-header-column-table
  min-height: 500px
  max-width: 100%

td.total:first-child
  background-color: #c1f4cd !important

tr th
  position: sticky
  z-index: 2
  background: #fff

thead tr:last-child th
  z-index: 3

thead tr:first-child th
  top: 0
  z-index: 1

tr:first-child th:first-child
  z-index: 3

td:first-child
  z-index: 1

td:first-child, th:first-child
  position: sticky
  left: 0
</style>

<style type="text/css">
.el-input {
  width: 200px;
}

.el-range-editor.el-input__inner {
  width: 410px;
}

body {
  font-size: 11px;
}

.q-card__section--vert {
  padding: 6px;
}

.q-card {
  width: 100%;
}

.q-pa-md {
  padding: 5px;
}

.f_right {
  right: 15px;
  position: absolute;
}
</style>

<style lang="scss">
.pointer {
  cursor: pointer;
}

.head_navbar {
  font-size: 20px;
  color: blue;
  text-transform: capitalize;
}

.px-15 {
  padding-left: 15px;
  padding-top: 15px;
  padding-bottom: 15px;
}

.pt-3 {
  padding-top: 15px;
}

.footer_filter {
  h5 {
    position: absolute;
    right: 15px;
    color: gray;
  }
}
</style>
